function varargout=sliceiso(self,u,P,varargin)
  % plot function u on plan defined by p(1)*x+p(2)*y+p(3)*z+p(4)=0
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('niso',10,@isscalar);
  %p.addParamValue('colormap','',@ischar);
  %p.addParamValue('colorbar',false,@islogical); % FC [04/01/2016] supprime-> appel externe
  p.addParamValue('color',[]); % unique color
  %p.addParamValue('PlotOptions',{},@iscell);
  p.addParamValue('isorange',[]);
  p.parse(varargin{:});
  R=p.Results;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  assert(self.d==3 && self.dim==3)
  assert(  (self.d==3) && self.dim==3 )
  if (isempty(R.isorange) && R.niso>1), R.isorange=linspace(min(u),max(u),R.niso);end
  R.niso=length(R.isorange); 
  if length(u)==self.nqGlobal
    ul=u(self.toGlobal);
  else
    assert(length(u)==self.nq);
    ul=u;
  end
  view(3)
  %s = extern.gptoolbox.tsurf([1 1 1],self.q','EdgeColor','none');
%caxis([min(u) max(u)]);
  [U,G,J,BC] = fc_tools.graphics.gptoolbox.slice_tets2(self.q',self.me',P);
  %set(s,'Vertices',U,'Faces',G,'CData',BC*ul);
  q=U;me=G; cData=BC*ul;
  [LS,LD,I] = fc_tools.graphics.gptoolbox.isolines(q,me,cData,R.isorange);
  
  if isempty(R.color)
    cmap=colormap();%R.colormap);
    t=0:1/(R.niso-1):1;
    colors = RGB(t,cmap);
  else
    if size(R.color,1)==1
      if ischar(R.color), R.color = fc_tools.graphics.colorstr2rgb(R.color);end
      colors=ones(R.niso,1)*R.color;
    else
      assert( (size(R.color,1)==R.niso) && (size(R.color,2)==3) )
      colors=R.color;
    end
  end
  
  PrevHold=fc_tools.graphics.SetHoldOn(true);
  %axis equal
  h=zeros(1,R.niso);
  for i=1:R.niso
    II=find(I==i);
    if isempty(II),h(i)=NaN;else
      N=length(II);
      X=[LS(II,1) LD(II,1) NaN(N,1)]';Y=[LS(II,2) LD(II,2) NaN(N,1)]';Z=[LS(II,3) LD(II,3) NaN(N,1)]';
      h(i)=plot3(X(:),Y(:),Z(:),'Tag',sprintf('isovalue : %g',R.isorange(i)),'color',colors(i,:),varargin{:}); 
    end
  end
  if nargout>=1, varargout{1}=colors;end
  if nargout>=2, varargout{2}=R.isorange;end
  if nargout==3, varargout{3}=h;end
  fc_tools.graphics.RestoreHold(PrevHold)
end